## bible-kjv 4.39

=== debian/changelog ===
bible-kjv (4.39) unstable; urgency=medium

  * Support rootless building (Closes: #1089291)

 -- Matthew Vernon <matthew@debian.org>  Sun, 08 Dec 2024 13:37:07 +0000
