=== debian/rules ===
#!/usr/bin/make -f
# Sample debian.rules file - for GNU Hello (1.3).
# Copyright 1994,1995 by Ian Jackson.
# I hereby give you perpetual unlimited permission to copy,
# modify and relicense this file, provided that you do not remove
# my name from the file itself.  (I assert my moral right of
# paternity under the Copyright, Designs and Patents Act 1988.)
# This file may have to be extensively modified

# There used to be `source' and `diff' targets in this file, and many
# packages also had `changes' and `dist' targets.  These functions
# have been taken over by dpkg-source, dpkg-genchanges and
# dpkg-buildpackage in a package-independent way, and so these targets
# are obsolete.

include /usr/share/dpkg/architecture.mk
-include /usr/share/dpkg/buildtools.mk

package=bible-kjv

build:
	$(checkdir)
	dpkg-architecture -a$(DEB_BUILD_ARCH) -f -c dh_auto_build --no-parallel -- bible-index.c bible.data bible.data.conc 'LD=$$(CC)'
	rm -f *.o
	dh_auto_build --no-parallel -- bible 'LD=$$(CC)'
	cd debian && $(CC) -g -O2 -ffile-prefix-map=$(CURDIR)=. -o randverse randverse.c
	touch build

build-arch: build

build-indep: build

clean:
	$(checkdir)
	-rm -f build
	-$(MAKE) clean
	-rm -f `find . -name "*~"`
	-rm -rf debian/tmp debian/files* bible debian/bible-kjv-text \
		debian/randverse debian/substvars randverse

binary-indep:	build
	$(checkdir)
	-rm -fr debian/tmp debian/bible-kjv-text/
	install -d debian/tmp/usr
	make install DEST=debian/tmp/usr
	install -d debian/bible-kjv-text debian/bible-kjv-text/DEBIAN
	install -m 755 debian/bible-kjv-text.postinst debian/bible-kjv-text/DEBIAN/postinst
	install -m 755 debian/bible-kjv-text.prerm debian/bible-kjv-text/DEBIAN/prerm
	cd debian/bible-kjv-text && install -d -m 775 `cat ../bible-kjv-text.dirs` 
	cp debian/copyright debian/bible-kjv-text/usr/share/doc/bible-kjv-text
	cp debian/changelog debian/bible-kjv-text/usr/share/doc/bible-kjv-text/changelog
	cp debian/text.readme debian/bible-kjv-text/usr/share/doc/bible-kjv-text/Debian.README
	gzip --best -n debian/bible-kjv-text/usr/share/doc/bible-kjv-text/Debian.README
	gzip --best -n debian/bible-kjv-text/usr/share/doc/bible-kjv-text/changelog
	cd debian/tmp && \
		mv `cat ../bible-kjv-text.files` ../bible-kjv-text/usr/lib
	dpkg-gencontrol -pbible-kjv-text -Pdebian/bible-kjv-text -isp
	chmod -R go=rX debian/bible-kjv-text
	dpkg-deb --build --root-owner-group debian/bible-kjv-text ..

binary-arch:	build
	$(checkdir)
	-rm -rf debian/tmp debian/bible-kjv-text/
	install -d debian/tmp debian/tmp/DEBIAN
	install -m 755 debian/postinst debian/tmp/DEBIAN
	install -m 755 debian/prerm debian/tmp/DEBIAN
	install -m 755 debian/postrm debian/tmp/DEBIAN
	install -d debian/tmp/usr/share/doc/$(package)
	install -d debian/tmp/usr/share/man/man1
	install -d debian/tmp/usr/bin debian/tmp/usr/lib
	make install DEST=debian/tmp/usr
	install -m 755 debian/randverse debian/tmp/usr/bin
	install -m 755 bible debian/tmp/usr/bin
	install -m 644 debian/randverse.1 debian/tmp/usr/share/man/man1
	dh_strip -p$(package) --tmpdir=debian/tmp
	cp debian/notes debian/copyright debian/tmp/usr/share/doc/$(package)/.
	cp debian/changelog debian/tmp/usr/share/doc/$(package)/changelog
	cp README* debian/README* debian/tmp/usr/share/doc/$(package)
	install -m 755 -d debian/tmp/usr/lib/menu
	install -m 644 debian/menu     debian/tmp/usr/lib/menu/$(package)
	chmod a+r debian/tmp/usr/share/doc/$(package)/*
	gzip -9 -n debian/tmp/usr/share/doc/$(package)/*
	gunzip -9 debian/tmp/usr/share/doc/$(package)/copyright.gz
	gzip -9 -n debian/tmp/usr/share/man/man1/*
	cd debian/tmp && \
		rm `cat ../bible-kjv-text.files`
	dpkg-shlibdeps bible
	dpkg-gencontrol -pbible-kjv -Pdebian/tmp -isp
	chmod -R g-ws debian/tmp
	dpkg-deb --build --root-owner-group debian/tmp ..

binary: binary-indep binary-arch

define checkdir
	test -f bible.c -a -f debian/rules
endef

source diff:
	@echo >&2 'source and diff are obsolete - use dpkg-source -b'; false

.PHONY: binary binary-arch binary-indep clean build-arch build-indep
