## bible-kjv 4.40

=== debian/changelog ===
bible-kjv (4.40) unstable; urgency=medium

  * Use dpkg-buildflags (Closes: #1119360)
  * Fix a bunch of not-checked-return values flagged by the above

 -- Matthew Vernon <matthew@debian.org>  Fri, 07 Nov 2025 14:34:47 +0000
