=== debian/changelog ===
bible-kjv (4.41) unstable; urgency=medium

  * Also apply buildflags to randverse build

 -- Matthew Vernon <matthew@debian.org>  Fri, 07 Nov 2025 15:31:45 +0000
