=== debian/tests/control ===
#Autopkg tests for the Bible package
Tests: bible-tests.sh
Restrictions: allow-stderr
